/*
 * Main.c
 *
 *  Created on: 2009/07/07
 *      Author: ashida
 */
#include <Feature.h>

/* ̂fBNg */
#define DICT_DIR "..\\DictionaryData\\"
/* bVʂ̎ */
#define MESH_DICTIONARY "Mesh.dict"
/* t@C̒ */
#define FILENAME_SIZE 1024
/* FŝfBNg */
#define RECOGNIZED_CHAR_DIR "..\\RecognizedData\\"
/* Fs */
#define RECOGNIZED_CHAR "4-00.pbm"

/* ̓ǂݍ */
static void _readDictionary(Dictionary *dictionary);
/* Fp^[ǂݍ */
static void _readRecognizedPattern(Bitmap *recognized_pattern);
/* ގxł𓾂 */
static unsigned int _getMostSimularPattern(Dictionary *dictionary, Bitmap *recognized_pattern);

/*----------------------------------------------------------------*/
/** C֐
 * 	@param argc p[^̐
 * 	@param argv p[^
 * 	@return ߂l
 */
int main(int argc, char **argv){

	/*  */
	Dictionary dictionary;
	/* Fp^[ */
	Bitmap recognized_pattern;
	/* R[h */
	unsigned int code;

	/* ̓ǂݍ */
	_readDictionary(&dictionary);

	/* Fp^[ǂݍ */
	_readRecognizedPattern(&recognized_pattern);

	/* ގxł𓾂 */
	code = _getMostSimularPattern(&dictionary, &recognized_pattern);

	printf("code = %c", code);
	/* ̉ */
	freeDictionary(&dictionary);
	freeBitmap(&recognized_pattern);

	return 0;
}
/*----------------------------------------------------------------*/
/**********************/
/* static֐ */
/**********************/
/* ̓ǂݍ */
static void _readDictionary(Dictionary *dictionary){
	/* t@C */
	char filename[FILENAME_SIZE];

	/* ̏ */
	initDictionary(dictionary, getMeshDimension());

	/* bVʂ̎t@C쐬 */
	sprintf(filename, "%s%s", DICT_DIR, MESH_DICTIONARY );
	/* ǂݍ */
	readDictionary(dictionary, filename);
}
/*----------------------------------------------------------------*/
/* Fp^[ǂݍ */
static void _readRecognizedPattern(Bitmap *recognized_pattern){
	/* t@C */
	char filename[FILENAME_SIZE];

	/* t@C쐬 */
	sprintf(filename, "%s%s", RECOGNIZED_CHAR_DIR, RECOGNIZED_CHAR);
	/* F镶p^[ǂݍ */
	readBitmap(recognized_pattern, filename);
}
/*----------------------------------------------------------------*/
/* ގxł𓾂 */
static unsigned int _getMostSimularPattern(Dictionary *dictionary, Bitmap *recognized_pattern){
	/* ϐ */
	int i;
	/* bV */
	Mesh dict_mesh, recognized_pattern_mesh;
	/*  */
	unsigned int distance;
	/* ŏ */
	unsigned int min_distance = 0xffffffff;
	/* ގxłႩR[h */
	unsigned int code;

	/* bVʂ̏ */
	initMeshFeature(&dict_mesh);
	initMeshFeature(&recognized_pattern_mesh);

	/* Fp^[̃bVʂ𓾂 */
	calcMeshFeature(&recognized_pattern_mesh, recognized_pattern);

	/* ɂvfJԂ */
	for(i=0; i<getElementNum(dictionary); i++){
		/* 1̓ʂbVʗpɕϊ */
		setSerialFeatureMesh(&dict_mesh, getFeature(dictionary,i));
		/* 𓾂 */
		distance = getDistanceMesh(&dict_mesh, &recognized_pattern_mesh);
		printf("distance = %d\n", distance);
		/* ŏł */
		if(distance < min_distance){
			/* R[h𓾂 */
			code = getCode(dictionary, i);
			/* ŏXV */
			min_distance = distance;
		}
	}
	return code;
}
/*----------------------------------------------------------------*/
