/*
 * Main.c
 *
 *  Created on: 2009/07/07
 *      Author: ashida
 */

#include <stdio.h>
#include <Feature.h>

/* F镶̐ */
#define CHAR_NUM 10
/* Ƃēo^镶̐ */
#define SAMPLE_NUM 10
/* ̂fBNg */
#define DICT_DIR "..\\DictionaryData\\"
/* bVʂ̎ */
#define MESH_DICTIONARY "Mesh.dict"

/* t@C̒ */
#define FILENAME_SIZE 1024

/* ׂẲ摜ǂݍ */
static void _readBitmaps(Bitmap bitmap[][SAMPLE_NUM], unsigned int code[]);
/* bVʂ𓾂 */
static void _getMeshFeature(Bitmap bitmaps[][SAMPLE_NUM], Mesh meshes[][SAMPLE_NUM]);
/* ƂĂɕۑ */
static void _writeMeshDictionary(Mesh meshes[][SAMPLE_NUM], unsigned int code[]);

/*------------------------------------------------------------------------------------*/
/* C֐ */
int main(int argc, char **argv){

	/* 摜 */
	Bitmap bitmaps[CHAR_NUM][SAMPLE_NUM];
	/* bV */
	Mesh meshes[CHAR_NUM][SAMPLE_NUM];
	/* R[h */
	unsigned int code[CHAR_NUM];

	/* 摜ǂݍ */
	_readBitmaps(bitmaps, code);

	/* bVʂ𓾂 */
	_getMeshFeature(bitmaps, meshes);

	/* ƂĂɕۑ */
	_writeMeshDictionary(meshes, code);

	/* ytFʂ𓾂 */
	/* Ƃĕۑ */

	return 1;
}
/*------------------------------------------------------------------------------------*/
/**********************/
/* static֐ */
/**********************/
/* 摜ǂݍ */
static void _readBitmaps(Bitmap bitmaps[][SAMPLE_NUM], unsigned int code[]){
	/* ϐ */
	int i,j;
	/* t@C */
	char filename[FILENAME_SIZE];

	/* F镶̐JԂ */
	for(i=0; i<CHAR_NUM; i++){
		/* Ƃēo^镶̐JԂ */
		for(j=0; j<SAMPLE_NUM; j++){
			/* rbg}bvt@C쐬 */
			sprintf(filename, "%s%d\\%d-%02d.pbm", DICT_DIR, i, i, j);
			/* t@C摜ǂݍ */
			readBitmap(&(bitmaps[i][j]), filename);
		}
		/* R[hL */
		code[i] = i+'0';
	}
}
/*------------------------------------------------------------------------------------*/
/* bVʂ𓾂 */
static void _getMeshFeature(Bitmap bitmaps[][SAMPLE_NUM], Mesh meshes[][SAMPLE_NUM]){
	/* ϐ */
	int i,j;

	/* F镶̐JԂ */
	for(j=0; j<CHAR_NUM; j++){
		/* Ƃēo^镶̐JԂ */
		for(i=0; i<SAMPLE_NUM; i++){
			/* bVʂ𓾂 */
			calcMeshFeature(&(meshes[j][i]), &(bitmaps[j][i]));
		}
	}

}
/*------------------------------------------------------------------------------------*/
/* ƂĂɕۑ */
static void _writeMeshDictionary(Mesh meshes[][SAMPLE_NUM], unsigned int code[]){
	/* ϐ */
	int i,j;
	/* v */
	Mesh sums[CHAR_NUM];
	/* t@C */
	char filename[FILENAME_SIZE];
	/*  */
	Dictionary dictionary;
	/* 1̔zƂē */
	unsigned int *serial_feature;

	/*  */
	initDictionary(&dictionary, getMeshDimension());


	/* F镶̐JԂ */
	for(j=0; j<CHAR_NUM; j++){
		/*  */
		initMeshFeature(&sums[j]);
		/* Ƃēo^镶̐JԂ */
		for(i=0; i<SAMPLE_NUM; i++){
			/* bVʂĂ */
			addMeshFeature(&(meshes[j][i]), &(sums[j]));
		}
		/* ς߂邽߁CTvŊ */
		divideMesh(&(sums[j]),CHAR_NUM);
		printf("code = %c\n", code[j]);
		/* \ */
		printMeshFeature(&(sums[j]));
		/* 1̔zƂēʂ𓾂 */
		serial_feature = getSerialFeatureMesh(&(sums[j]));
		/* ɒǉ */
		addElement(&dictionary, code[j], serial_feature );
	}
	/* bVʂ̎t@C쐬 */
	sprintf(filename, "%s%s", DICT_DIR, MESH_DICTIONARY );
	/* ۑ */
	writeDictionary(&dictionary, filename);

	/* ̃ */
	freeDictionary(&dictionary);
}
/*------------------------------------------------------------------------------------*/
